# Measure the time it takes to execute the file
start_time_UK_LOOCV <- Sys.time()
  

# 
# #To avoid what we suppose wrong observations, we will subtitute the values higher than limit microg/m3
# w <- length(which(df_obs$pollutant>limit))
# if(w>=1){
#   df_obs[df_obs$pollutant>limit,"pollutant"] <- limit
#   print(paste0("The observations has been modified to exceed ", limit, " límit value. The number of observations modified are : ", w, " in the hour:", hour))
# }

############################################################
#                                                          #
#                 Loop UK - LOOCV                          #
#                                                          #
############################################################
print("Loop UK - LOOCV")
#LOOCV_total and model_raw_at_AQMS is created empty to fill it later with LOOCV and raw model data respectivelly

if (execute_uk) {
  UK_total <- list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
}
if (execute_loocv) {
  LOOCV_total <- matrix(NA,ncol=nrow(local_stations@data),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
  colnames(LOOCV_total) <- local_stations$ref_obs #we want a matrix with empty data and the name of stations
}
if (execute_uk=="FALSE" && execute_loocv=="FALSE") {
  print("The user did not choose any method to apply")
}


#starting OK and LOOCV:
for (hour in 1:length_loop) {
  print(paste0("loop UK or LOOCV number:",hour))
  
  #    1.1. Set spatialpointsdataframe
  #raw model:
  df_model_uk                  <- model[,,hour]
  df_model_uk                  <- data.frame(lat=lat_model,lon=lon_model,pollutant_model=sapply(df_model_uk,as.matrix))
  coordinates(df_model_uk)     <- ~lon+lat
  sp::proj4string(df_model_uk) <- crs_latlon
  
  #config the coordinates in UTM
  if (compute_in_UTM) {
    df_model_uk <- spTransform(df_model_uk, sp::CRS(crs_utm))
  }
  #extract observations hourly
  
  if(time_resolution=="hourly"){
    df_obs_hour <- df_obs_sub[hour,-1] 
  }else if(time_resolution=="daily"){
    df_obs_hour <- df_obs_sub[, !names(df_obs_sub) %in% different_names]
    df_obs_hour <- df_obs_hour[hour,]
  } else{
    print("Wrong time resolution")
  }
  # posar aqui lo del limit? 
  #??? pk?
  # #LOOCV don't work if there is any NA, so first we will remove negative obs and then substitute NA from model value (it will improve using other methods of gap filling)
  # if(isTRUE(anyNA(df_obs_hour)) | isTRUE(any(df_obs_hour<0))){
  #   
  #   df_obs_hour[sapply(df_obs_hour, is.numeric)] <- lapply(df_obs_hour[sapply(df_obs_hour,is.numeric)],function(x) replace(x, x<0,NA))
  #   
  #   # Seleccionar solo las filas con datos completos
  #   #!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  #   df_obs_hour                                  <- na.omit(df_obs_hour) #aqui tinc el problemita, m'elimina tot
  #   
  #   #df_obs_hour[df_obs_hour<0] <- ifelse(df_obs_hour<0, NA, df_obs_hour[df_obs_hour<0]) # substitutes negative values to NA
  #   #df_obs_hour <-  coalesce(df_obs_hour, model_raw_at_AQMS[hour,]) # Also, it can be done as: df_obs_hour[is.na(df_obs_hour)] <- model_raw_at_AQMS[n,][is.na(df_obs_hour)]
  #   
  #   print(paste0("Negative or NA in the observations has been substituted by zero in the hour:", " ", hour))
  # }
  
  model_raw_at_AQMS <- model_raw_at_AQMS_df
  
  ok_hour <- model_raw_at_AQMS[hour,!(names(model_raw_at_AQMS) %in% different_names)]
  
  
  
  df_loocv                     <- data.frame(lat=local_stations@coords[,2],
                                             lon=local_stations@coords[,1],
                                             pollutant_model=as.numeric(ok_hour[1,]),
                                             ref_obs=local_stations@data$ref_obs)
  
  df_obs_loocv <- data.frame(pollutant_obs = as.numeric(df_obs_hour[1,]) , ref_obs = colnames(df_obs_hour))
  
  llista_loocv <- merge(df_loocv, df_obs_loocv, by = "ref_obs")
  
  llista_loocv <- na.omit(llista_loocv) #aqui tinc el problemita, m'elimina tot
  
  # Jan: dona problema local_stations i  df_obs_hour no tenen mateixes dims. A dalt una possibilitat per arreglar-ho.
  # Jan: Això no passava també abans?
  
  # #We will generate a data frame with obs and raw-model interpolated in the local stations
  # llista_loocv                     <- data.frame(lat=local_stations@coords[,2],
  #                                                lon=local_stations@coords[,1],
  #                                                pollutant_obs=as.numeric(df_obs_hour[1,]),
  #                                                pollutant_model=as.numeric(ok_hour[1,]),
  #                                                code=colnames(df_obs_hour))
  
  
  coordinates(llista_loocv)        <- ~lon+lat
  sp::proj4string(llista_loocv)    <- crs_latlon
  
  #config the coordinates in UTM
  if (compute_in_UTM) {
    llista_loocv <- spTransform(llista_loocv, sp::CRS(crs_utm))
  } else {
    sp::proj4string(llista_loocv) <- crs_latlon
  }
  
  # Compute LOOCV variogram
  
  pollutant.fit_loocv <- automap::autofitVariogram(formula=pollutant_obs~pollutant_model,input_data=llista_loocv, verbose=FALSE)
  
  #Emergency Variogram if range of the current Variogram it's negative
  if(any(pollutant.fit_loocv$var_model$range<0)){
    print('UK Variogram had negative range')
    pollutant.fit_loocv=readRDS(variogram_uk)
  }
  
  #coef(lm(pollutant_obs ~  pollutant_model , llista_uk))['pollutant_model'] is the same as slope:
  slope <- summary(lm(pollutant_obs ~  pollutant_model , llista_loocv))$coefficients[,1][-1] 
  #p     <-summary(lm(pollutant_obs ~  pollutant_model , llista_uk))$coefficients[,4][-1] #p value.
  
  if(slope[1] < 0){
    
    #ok_loocv              <- NULL
    ok_loocv              <- as.data.frame(llista_loocv$pollutant_model)
    colnames(ok_loocv)    <- c("var1.pred")
    coordinates(ok_loocv) <- llista_loocv@coords
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      sp::proj4string(ok_loocv) <- crs_utm
    } else {
      sp::proj4string(ok_loocv) <- crs_latlon
    }
    
    print(paste0("The slope in hour ", hour, " is ", slope, ". We did not apply LOOCV, raw-model value is picked for this hour"))
    
  }else {
    
    if(execute_uk){
      uk_gstat   <- gstat(formula=pollutant_obs~pollutant_model,data=llista_loocv, model = pollutant.fit_loocv$var_model)
      #!!!! Mirar el df_model_uk primer d'on ve, i  segon fer un df_model_uk <- model[,,hour] o semblant
      #path del UK: /esarchive/scratch/mhajji/Meriem/UK_regional/UK_final.R
      uk_interpolation    <- predict(object=uk_gstat, newdata=df_model_uk)
    }
    
    if(execute_loocv){
      # LOOCV
      loocv_interpolation  <- krige.cv(pollutant_obs~pollutant_model,llista_loocv,pollutant.fit_loocv$var_model)
      }
  }
  
  if(execute_uk){
    UK_total[[hour]]       <- uk_interpolation@data$var1.pred
  }
  if(execute_loocv){
    uk_loocv_h             <- matrix(data=loocv_interpolation@data$var1.pred, nrow=1)
    colnames(uk_loocv_h)   <- llista_loocv@data$ref_obs
    LOOCV_total            <- plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(uk_loocv_h))
  }
  
}

if(execute_loocv){
  LOOCV_total_df        <- as.data.frame(LOOCV_total)
  for(i in 1:nrow(local_stations)){
    LOOCV_total_df[[i]] <- replace(LOOCV_total_df[[i]], LOOCV_total_df[[i]]<0, 0)
  }
  
  #UK_LOOCV_total_df <- cbind(dates,UK_LOOCV_total_df_wd)
  LOOCV_total_df        <- cbind(date = date_times$date, LOOCV_total_df)
  #Verification of negative values 'which(model_raw_at_AQMS_df<0)'. 
  #At the moment we don't apply it to model_raw_at_AQMS because it doesn't have negative values
}



if (save_LOOCV){
  if(execute_uk){
    saveRDS(object=UK_total, file = paste0(save_result,"UK_",file_format, "_",pollutant,"_df.rds")) 
    print("UK saved")
  }
  if(execute_loocv){
    saveRDS(object=LOOCV_total_df, file = paste0(save_result,"LOOCV_",file_format, "_",pollutant,"_df.rds"))
    print("LOOCV saved")
  }
  
} else {
  print("LOOCV - UK have not been saved")
}

end_time_UK_LOOCV     <- Sys.time()
temps_total_UK_LOOCV  <- end_time_UK_LOOCV  - start_time_UK_LOOCV 
print(paste0("UK or LOOCV, execution time:",temps_total_UK_LOOCV , "s" ))
