#Aquest fitxer es per agafar les dades del model d'un any, interpolarem a una malla uniforme per despres fer la media anual i el 19 èvalor max i plotejar en forma de pixels aquestes mitjes anuals

start_time <- Sys.time()

############################################################
#                                                          #
#                        LOAD LIBRARY                      #
#                                                          #
############################################################

library(urbanR)
library(RNetCDF)
library(ncdf4)
library(rgeos) 
library(ggplot2)
library(plyr) #OJO! la llibreria plyr ha de ser cridada abans que dplyr pk aixi ho vol el programa
library(dplyr)
library(broom)
library(magrittr)
library(ggpubr)
library(raster)
library(rgdal)
library(gstat)
library(sp)
library(abind)
library(ggmap)
library(reshape)
library(sfsmisc)
library(sp)
library(akima)

############################################################
#                                                          #
#              LOAD MODEL INTERPOLATED                     #
#                                                          #
############################################################

# LOAD config_file
args = commandArgs(TRUE)
if (length(args) > 0) {
  configFile_path <- args[1]
} else {
  cat("\n***WARNING: no ConfigFile was provided. Using default ConfigFile.\n")
}

#configFile_path <- "/esarchive/scratch/mhajji/pixels/RUN_pixels/config_file.yml"
config           <- yaml::yaml.load_file(configFile_path)
sim_folder_path  <- config$sim_folder_path   # path where we save the results
model_interpolat =  config$model_interpolat  # path where we have the data 
model_int        <-readRDS(file=paste0(model_interpolat,"Uk_results.rds")) 
#data (var1.pred) in a list of 48 h (bc we have data for 2 days) SpecialPointsDataFrame 
#UK_spdf = readRDS(file=paste0(model_interpolat, "Uk_spatialpoints.rds")

############################################################
#                                                          #
#                           PIXELS                         #
#                                                          #
############################################################

#LOAD MODEL

crs_model       <- "+proj=longlat +datum=WGS84 +ellps=WGS84 +towgs84=0,0,0" 

lat_model      <- model_int[[1]]@coords[,2]
lat_model      <- sapply(lat_model, as.numeric)

lon_model      <- model_int[[1]]@coords[,1]
lon_model      <- sapply(lon_model, as.numeric)

n_points_model  <- nrow(model_int[[1]]@data)
n_hours         <- length(model_int)
NO2_matrix      <- matrix(data=NA, nrow=n_points_model,ncol = n_hours )

#model       <- model_int[[i]]@data$var1.pred
dades1=model_int[[1]] #potser no

for(h in 1:n_hours) {
	NO2_matrix[,h] <-  model_int[[h]]@data$var1.pred
}

NO2_mean              <- rowMeans(NO2_matrix, na.rm = TRUE)
dades1@data$var1.pred = NO2_mean
mean_uniform          <- interp(x=dades1,z="var1.pred",nx=300,ny=300) #int the means of the model to an uniform "malla" of 1000x1000
#map= mapview::mapview(mean_uniform)

saveRDS(object=map, file=paste0(sim_folder_path,"UK_means_plot.png"))
saveRDS(object=mean_uniform, file=paste0( sim_folder_path,"UK_means_uniform.rds"))


end_time <- Sys.time()

temps_total <- end_time-start_time
print(temps_total)

